/**
 *******************************************************************************
 * @file  adc.h
 * @brief A/D converter driver header file
 * 
 * @note 
 * Copyright (C) 2015 Renesas Electronics Corporation 
 * Copyright (C) 2015 Renesas System Design Co., Ltd. 
 * 
 * @par
 *  This is a sample program. 
 *  Renesas Electronics assumes no responsibility for any losses incurred. 
 * 
 *******************************************************************************
 */

#ifndef	ADC_H__
#define	ADC_H__

/*==========================================================================*/
/* I N C L U D E															*/
/*==========================================================================*/
#include "RIN32M4.h"
#include "errcodes.h"

/*==========================================================================*/
/* T Y P E D E F															*/
/*==========================================================================*/

/*==========================================================================*/
/* D E F I N E																*/
/*==========================================================================*/

/*==========================================================================*/
/* E X T E R N                                                              */
/*==========================================================================*/

/*==========================================================================*/
/* P R O T O T Y P E                                                        */
/*==========================================================================*/
ER_RET adc_swtrg_init( uint8_t ch );
ER_RET adc_hwtrg_init( uint8_t ch );
void adc_start( void );
void adc_stop( void );
ER_RET adc_read( uint8_t ch, uint32_t* data );

#endif // ADC_H__
