/**
 *******************************************************************************
 * @file  iic.h
 * @brief I2C driver header
 * 
 * @note 
 * Copyright (C) 2015 Renesas Electronics Corporation 
 * Copyright (C) 2015 Renesas System Design Co., Ltd. 
 * 
 * @par
 *  This is a sample program. 
 *  Renesas Electronics assumes no responsibility for any losses incurred. 
 * 
 *******************************************************************************
 */

#ifndef	IIC_H__
#define	IIC_H__

/*============================================================================*/
/* I N C L U D E                                                              */
/*============================================================================*/
#include "RIN32M4.h"
#include "errcodes.h"

/*============================================================================*/
/* T Y P E D E F                                                              */
/*============================================================================*/

/*============================================================================*/
/* D E F I N E                                                                */
/*============================================================================*/

/*============================================================================*/
/* P R O T O T Y P E                                                          */
/*============================================================================*/
ER_RET iic_init(uint8_t ch);
ER_RET iic_start_condition(uint8_t ch);
ER_RET iic_stop_condition(uint8_t ch);
ER_RET iic_write(uint8_t ch, uint8_t data);
ER_RET iic_read(uint8_t ch, uint8_t *data, uint32_t last);

#endif // IIC_H__
