/**
 *******************************************************************************
 * @file  uart.h
 * @brief UART driver program
 * 
 * @note 
 * Copyright (C) 2015 Renesas Electronics Corporation 
 * Copyright (C) 2015 Renesas System Design Co., Ltd. 
 * 
 * @par
 *  This is a sample program. 
 *  Renesas Electronics assumes no responsibility for any losses incurred. 
 * 
 *******************************************************************************
 */

#ifndef	UART_H__
#define	UART_H__

/*============================================================================*/
/* I N C L U D E                                                              */
/*============================================================================*/
#include "RIN32M4.h"
#include "errcodes.h"

/*============================================================================*/
/* T Y P E D E F                                                              */
/*============================================================================*/

/*============================================================================*/
/* D E F I N E                                                                */
/*============================================================================*/

/*============================================================================*/
/* P R O T O T Y P E                                                          */
/*============================================================================*/
ER_RET uart_init(uint8_t ch);
ER_RET uart_write(uint8_t ch,uint8_t data);
ER_RET uart_read(uint8_t ch,uint8_t* data);
ER_RET uart_check_receivedata(uint8_t ch);

#endif // UART_H__
