/***********************************************************************/
/*  FlashDev.c:  Device Description for                                */
/*               Renesas R-IN32M4 Device and                           */
/*               Spansion MX25L6433F Serial Flash                      */
/*                                                                     */
/***********************************************************************/

#include "..\FlashOS.H"        // FlashOS Structures


struct FlashDevice const FlashDevice  =  {
   FLASH_DRV_VERS,              // Driver Version, do not modify!
   "R-IN32M4 MX25L6433F Flash", // Device Name
   EXTSPI,                      // Device Type
   0x02000000,                  // Device Start Address
   0x00800000,                  // Device Size in Bytes (64Mbit=8MB)
   256,                         // Programming Page Size (256-byte page size)
   0,                           // Reserved, must be 0
   0xFF,                        // Initial Content of Erased Memory
   300,                         // Program Page Timeout 300 mSec
   3000,                        // Erase Sector Timeout 3000 mSec

// Specify Size and Address of Sectors
   0x010000, 0x000000,          // Sector Size 64kB 
   SECTOR_END
};
