/***********************************************************************/
/*  FlashDev.c:  Device Description for                                */
/*               Renesas R-IN32M4 Device and                           */
/*               Spansion S29GL128S External NOR Flash  (16-bit Bus)   */
/*                                                                     */
/***********************************************************************/

#include "..\FlashOS.H"        // FlashOS Structures


struct FlashDevice const FlashDevice  =  {
   FLASH_DRV_VERS,             // Driver Version, do not modify!
   "R-IN32M4 S29GL128S Flash", // Device Name
   EXT16BIT,                   // Device Type
   0x10000000,                 // Device Start Address
   0x01000000,                 // Device Size in Bytes (128Mbit=16Mbyte)
   1024,                       // Programming Page Size (512-byte page size)
   0,                          // Reserved, must be 0
   0xFF,                       // Initial Content of Erased Memory
   300,                        // Program Page Timeout 300 mSec
   3000,                       // Erase Sector Timeout 3000 mSec

// Specify Size and Address of Sectors
   0x020000, 0x000000,         // Sector Size  128kB (?128 Sectors) 
   SECTOR_END
};
